// LEDキャンドル
// 2017.12 nakayasu
 
int led = 3;          // LEDピンの指定
int brightness = 0;   // LEDのPWM値のための変数
int sensorValue[4];   // 3軸加速度センサー、ECM
int ledStatus = 0;    // LEDのON/OFF切り替え用
int counter = 0;      // 手の揺れ戻しを無視するためのインターバルカウンター

void setup()
{
    pinMode(led, OUTPUT);
    for(int k=0; k<4; k++) sensorValue[k] = 0; //配列の初期化
}

void loop()
{
    //アナログ値の取得
    sensorValue[0] = analogRead(0); //A0 connect to ECM
    delay(10); //変換処理時間の確保
    sensorValue[1] = analogRead(1); //A1 connect to Z(7pin) on KXM52-1050
    delay(10);
    sensorValue[2] = analogRead(2); //A2 connect to Y(6pin) on KXM52-1050
    delay(10);
    sensorValue[3] = analogRead(3); //A3 connect to X(6pin) on KXM52-1050
    delay(10);
    
    //センサー値10bit（0〜1023）からLEDのPWM制御値8bitへ（0〜255）に変換する
    //Z方向の加速度をLEDの揺らぎにそのまま利用
    brightness = map(sensorValue[1], 1000, 1023, 0, 255);
 
    if(counter > 22) { 
      if(sensorValue[2]<420 || sensorValue[3]<420 || sensorValue[0]<80) {
        //X方向またはY方向の加速度が閾値を超えたとき、またはECMの入力が閾値を超えたときにLEDをON/OFFする
        //デフォルトの420や80は実験から求めた値で、数字が大きくなれば感度が良くなる。
        ledStatus = !ledStatus;
        counter = 0;
      }
    } else {
      counter++;
    }
 
    if(ledStatus==1) analogWrite(led, brightness); else analogWrite(led, 0);
}
